"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ExtendedCircomVisitor = void 0;
const generated_1 = require("./generated");
class ExtendedCircomVisitor extends generated_1.CircomVisitor {
    templateIdentifier;
    errors;
    constructor(templateIdentifier) {
        super();
        this.templateIdentifier = templateIdentifier;
        this.errors = [];
    }
    addError(message, context) {
        this.errors.push({
            templateName: this.templateIdentifier,
            message,
            line: context.start.line,
            column: context.start.column,
            context,
        });
    }
    getErrors() {
        return this.errors;
    }
}
exports.ExtendedCircomVisitor = ExtendedCircomVisitor;
