"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ParserError = void 0;
class ParserError extends Error {
    errors;
    constructor(args) {
        super();
        let firstError;
        if (Array.isArray(args)) {
            this.errors = args;
            firstError = args[0];
        }
        else {
            this.errors = [args];
            firstError = args;
        }
        const { message, line, column } = firstError;
        this.message = `${message} (${line}:${column})`;
    }
}
exports.ParserError = ParserError;
