import { ATN, DFA, FailedPredicateException, Parser, RuleContext, ParserRuleContext, TerminalNode, Token, TokenStream } from 'antlr4';
import CircomParserListener from "./CircomParserListener.js";
import CircomParserVisitor from "./CircomParserVisitor.js";
export default class CircomParser extends Parser {
    static readonly VERSION = 1;
    static readonly SIGNAL_TYPE = 2;
    static readonly PRAGMA = 3;
    static readonly CIRCOM = 4;
    static readonly CUSTOM_TEMPLATES = 5;
    static readonly INCLUDE = 6;
    static readonly CUSTOM = 7;
    static readonly PARALLEL = 8;
    static readonly BUS = 9;
    static readonly TEMPLATE = 10;
    static readonly FUNCTION = 11;
    static readonly MAIN = 12;
    static readonly PUBLIC = 13;
    static readonly COMPONENT = 14;
    static readonly VAR = 15;
    static readonly SIGNAL = 16;
    static readonly INPUT = 17;
    static readonly OUTPUT = 18;
    static readonly IF = 19;
    static readonly ELSE = 20;
    static readonly FOR = 21;
    static readonly WHILE = 22;
    static readonly DO = 23;
    static readonly LOG = 24;
    static readonly ASSERT = 25;
    static readonly RETURN = 26;
    static readonly LP = 27;
    static readonly RP = 28;
    static readonly LB = 29;
    static readonly RB = 30;
    static readonly LC = 31;
    static readonly RC = 32;
    static readonly SEMICOLON = 33;
    static readonly DOT = 34;
    static readonly COMMA = 35;
    static readonly UNDERSCORE = 36;
    static readonly TERNARY_CONDITION = 37;
    static readonly TERNARY_ALTERNATIVE = 38;
    static readonly EQ_CONSTRAINT = 39;
    static readonly LEFT_CONSTRAINT = 40;
    static readonly LEFT_ASSIGNMENT = 41;
    static readonly RIGHT_CONSTRAINT = 42;
    static readonly RIGHT_ASSIGNMENT = 43;
    static readonly SELF_OP = 44;
    static readonly NOT = 45;
    static readonly BNOT = 46;
    static readonly POW = 47;
    static readonly MUL = 48;
    static readonly DIV = 49;
    static readonly QUO = 50;
    static readonly MOD = 51;
    static readonly ADD = 52;
    static readonly SUB = 53;
    static readonly SHL = 54;
    static readonly SHR = 55;
    static readonly BAND = 56;
    static readonly BXOR = 57;
    static readonly BOR = 58;
    static readonly EQ = 59;
    static readonly NEQ = 60;
    static readonly GT = 61;
    static readonly LT = 62;
    static readonly LE = 63;
    static readonly GE = 64;
    static readonly AND = 65;
    static readonly OR = 66;
    static readonly ASSIGNMENT = 67;
    static readonly ASSIGNMENT_WITH_OP = 68;
    static readonly ID = 69;
    static readonly NUMBER = 70;
    static readonly HEX = 71;
    static readonly STRING = 72;
    static readonly COMMENT = 73;
    static readonly LINE_COMMENT = 74;
    static readonly WS = 75;
    static readonly EOF: number;
    static readonly RULE_circuit = 0;
    static readonly RULE_signalHeader = 1;
    static readonly RULE_busHeader = 2;
    static readonly RULE_pragmaDefinition = 3;
    static readonly RULE_includeDefinition = 4;
    static readonly RULE_blockDefiniton = 5;
    static readonly RULE_functionDefinition = 6;
    static readonly RULE_templateDefinition = 7;
    static readonly RULE_busDefinition = 8;
    static readonly RULE_publicInputsDefinition = 9;
    static readonly RULE_tagDefinition = 10;
    static readonly RULE_logDefinition = 11;
    static readonly RULE_assertDefinition = 12;
    static readonly RULE_declarations = 13;
    static readonly RULE_varDeclaration = 14;
    static readonly RULE_signalDeclaration = 15;
    static readonly RULE_componentDeclaration = 16;
    static readonly RULE_busDeclaration = 17;
    static readonly RULE_componentMainDeclaration = 18;
    static readonly RULE_body = 19;
    static readonly RULE_statements = 20;
    static readonly RULE_ifStatements = 21;
    static readonly RULE_regularStatements = 22;
    static readonly RULE_cycleStatements = 23;
    static readonly RULE_substitutions = 24;
    static readonly RULE_expressionList = 25;
    static readonly RULE_expressionListWithNames = 26;
    static readonly RULE_expression = 27;
    static readonly RULE_primaryExpression = 28;
    static readonly RULE_assignmentExpression = 29;
    static readonly RULE_varIdentifier = 30;
    static readonly RULE_varIdentifierList = 31;
    static readonly RULE_signalIdentifier = 32;
    static readonly RULE_signalIdentifierList = 33;
    static readonly RULE_identifierStatement = 34;
    static readonly RULE_identifier = 35;
    static readonly RULE_identifierList = 36;
    static readonly RULE_simpleIdentifierList = 37;
    static readonly RULE_idetifierAccess = 38;
    static readonly RULE_arrayDimension = 39;
    static readonly RULE_identifierReferance = 40;
    static readonly RULE_expressionOrString = 41;
    static readonly RULE_expressionOrStringList = 42;
    static readonly literalNames: (string | null)[];
    static readonly symbolicNames: (string | null)[];
    static readonly ruleNames: string[];
    get grammarFileName(): string;
    get literalNames(): (string | null)[];
    get symbolicNames(): (string | null)[];
    get ruleNames(): string[];
    get serializedATN(): number[];
    protected createFailedPredicateException(predicate?: string, message?: string): FailedPredicateException;
    constructor(input: TokenStream);
    circuit(): CircuitContext;
    signalHeader(): SignalHeaderContext;
    busHeader(): BusHeaderContext;
    pragmaDefinition(): PragmaDefinitionContext;
    includeDefinition(): IncludeDefinitionContext;
    blockDefiniton(): BlockDefinitonContext;
    functionDefinition(): FunctionDefinitionContext;
    templateDefinition(): TemplateDefinitionContext;
    busDefinition(): BusDefinitionContext;
    publicInputsDefinition(): PublicInputsDefinitionContext;
    tagDefinition(): TagDefinitionContext;
    logDefinition(): LogDefinitionContext;
    assertDefinition(): AssertDefinitionContext;
    declarations(): DeclarationsContext;
    varDeclaration(): VarDeclarationContext;
    signalDeclaration(): SignalDeclarationContext;
    componentDeclaration(): ComponentDeclarationContext;
    busDeclaration(): BusDeclarationContext;
    componentMainDeclaration(): ComponentMainDeclarationContext;
    body(): BodyContext;
    statements(): StatementsContext;
    ifStatements(): IfStatementsContext;
    regularStatements(): RegularStatementsContext;
    cycleStatements(): CycleStatementsContext;
    substitutions(): SubstitutionsContext;
    expressionList(): ExpressionListContext;
    expressionListWithNames(): ExpressionListWithNamesContext;
    expression(): ExpressionContext;
    expression(_p: number): ExpressionContext;
    primaryExpression(): PrimaryExpressionContext;
    assignmentExpression(): AssignmentExpressionContext;
    varIdentifier(): VarIdentifierContext;
    varIdentifierList(): VarIdentifierListContext;
    signalIdentifier(): SignalIdentifierContext;
    signalIdentifierList(): SignalIdentifierListContext;
    identifierStatement(): IdentifierStatementContext;
    identifier(): IdentifierContext;
    identifierList(): IdentifierListContext;
    simpleIdentifierList(): SimpleIdentifierListContext;
    idetifierAccess(): IdetifierAccessContext;
    arrayDimension(): ArrayDimensionContext;
    identifierReferance(): IdentifierReferanceContext;
    expressionOrString(): ExpressionOrStringContext;
    expressionOrStringList(): ExpressionOrStringListContext;
    sempred(localctx: RuleContext, ruleIndex: number, predIndex: number): boolean;
    private expression_sempred;
    static readonly _serializedATN: number[];
    private static __ATN;
    static get _ATN(): ATN;
    static DecisionsToDFA: DFA[];
}
export declare class CircuitContext extends ParserRuleContext {
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    EOF(): TerminalNode;
    pragmaDefinition_list(): PragmaDefinitionContext[];
    pragmaDefinition(i: number): PragmaDefinitionContext;
    includeDefinition_list(): IncludeDefinitionContext[];
    includeDefinition(i: number): IncludeDefinitionContext;
    blockDefiniton_list(): BlockDefinitonContext[];
    blockDefiniton(i: number): BlockDefinitonContext;
    componentMainDeclaration(): ComponentMainDeclarationContext;
    get ruleIndex(): number;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class SignalHeaderContext extends ParserRuleContext {
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    SIGNAL(): TerminalNode;
    SIGNAL_TYPE(): TerminalNode;
    tagDefinition(): TagDefinitionContext;
    get ruleIndex(): number;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class BusHeaderContext extends ParserRuleContext {
    _wireType: Token;
    _parameters: ExpressionListContext;
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    ID(): TerminalNode;
    tagDefinition(): TagDefinitionContext;
    SIGNAL_TYPE(): TerminalNode;
    LP(): TerminalNode;
    RP(): TerminalNode;
    expressionList(): ExpressionListContext;
    get ruleIndex(): number;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class PragmaDefinitionContext extends ParserRuleContext {
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    get ruleIndex(): number;
    copyFrom(ctx: PragmaDefinitionContext): void;
}
export declare class PragmaCustomTemplatesContext extends PragmaDefinitionContext {
    constructor(parser: CircomParser, ctx: PragmaDefinitionContext);
    PRAGMA(): TerminalNode;
    CUSTOM_TEMPLATES(): TerminalNode;
    SEMICOLON(): TerminalNode;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class PragmaVersionContext extends PragmaDefinitionContext {
    constructor(parser: CircomParser, ctx: PragmaDefinitionContext);
    PRAGMA(): TerminalNode;
    CIRCOM(): TerminalNode;
    VERSION(): TerminalNode;
    SEMICOLON(): TerminalNode;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class PragmaInvalidVersionContext extends PragmaDefinitionContext {
    constructor(parser: CircomParser, ctx: PragmaDefinitionContext);
    PRAGMA(): TerminalNode;
    CIRCOM(): TerminalNode;
    SEMICOLON(): TerminalNode;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class IncludeDefinitionContext extends ParserRuleContext {
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    INCLUDE(): TerminalNode;
    STRING(): TerminalNode;
    SEMICOLON(): TerminalNode;
    get ruleIndex(): number;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class BlockDefinitonContext extends ParserRuleContext {
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    functionDefinition(): FunctionDefinitionContext;
    templateDefinition(): TemplateDefinitionContext;
    busDefinition(): BusDefinitionContext;
    get ruleIndex(): number;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class FunctionDefinitionContext extends ParserRuleContext {
    _argNames: SimpleIdentifierListContext;
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    FUNCTION(): TerminalNode;
    ID(): TerminalNode;
    LP(): TerminalNode;
    RP(): TerminalNode;
    body(): BodyContext;
    simpleIdentifierList(): SimpleIdentifierListContext;
    get ruleIndex(): number;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class TemplateDefinitionContext extends ParserRuleContext {
    _argNames: SimpleIdentifierListContext;
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    TEMPLATE(): TerminalNode;
    ID(): TerminalNode;
    LP(): TerminalNode;
    RP(): TerminalNode;
    body(): BodyContext;
    CUSTOM(): TerminalNode;
    PARALLEL(): TerminalNode;
    simpleIdentifierList(): SimpleIdentifierListContext;
    get ruleIndex(): number;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class BusDefinitionContext extends ParserRuleContext {
    _argNames: SimpleIdentifierListContext;
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    BUS(): TerminalNode;
    ID(): TerminalNode;
    LP(): TerminalNode;
    RP(): TerminalNode;
    body(): BodyContext;
    simpleIdentifierList(): SimpleIdentifierListContext;
    get ruleIndex(): number;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class PublicInputsDefinitionContext extends ParserRuleContext {
    _publicInputs: SimpleIdentifierListContext;
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    LC(): TerminalNode;
    PUBLIC(): TerminalNode;
    LB(): TerminalNode;
    RB(): TerminalNode;
    RC(): TerminalNode;
    simpleIdentifierList(): SimpleIdentifierListContext;
    get ruleIndex(): number;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class TagDefinitionContext extends ParserRuleContext {
    _values: SimpleIdentifierListContext;
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    LC(): TerminalNode;
    RC(): TerminalNode;
    simpleIdentifierList(): SimpleIdentifierListContext;
    get ruleIndex(): number;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class LogDefinitionContext extends ParserRuleContext {
    _logArgs: ExpressionOrStringListContext;
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    LOG(): TerminalNode;
    LP(): TerminalNode;
    RP(): TerminalNode;
    expressionOrStringList(): ExpressionOrStringListContext;
    get ruleIndex(): number;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class AssertDefinitionContext extends ParserRuleContext {
    _assertArgs: ExpressionContext;
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    ASSERT(): TerminalNode;
    LP(): TerminalNode;
    RP(): TerminalNode;
    expression(): ExpressionContext;
    get ruleIndex(): number;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class DeclarationsContext extends ParserRuleContext {
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    varDeclaration(): VarDeclarationContext;
    signalDeclaration(): SignalDeclarationContext;
    componentDeclaration(): ComponentDeclarationContext;
    busDeclaration(): BusDeclarationContext;
    get ruleIndex(): number;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class VarDeclarationContext extends ParserRuleContext {
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    VAR(): TerminalNode;
    LP(): TerminalNode;
    identifierList(): IdentifierListContext;
    RP(): TerminalNode;
    assignmentExpression(): AssignmentExpressionContext;
    varIdentifierList(): VarIdentifierListContext;
    get ruleIndex(): number;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class SignalDeclarationContext extends ParserRuleContext {
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    signalHeader(): SignalHeaderContext;
    LP(): TerminalNode;
    identifierList(): IdentifierListContext;
    RP(): TerminalNode;
    assignmentExpression(): AssignmentExpressionContext;
    signalIdentifierList(): SignalIdentifierListContext;
    get ruleIndex(): number;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class ComponentDeclarationContext extends ParserRuleContext {
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    COMPONENT(): TerminalNode;
    LP(): TerminalNode;
    identifierList(): IdentifierListContext;
    RP(): TerminalNode;
    assignmentExpression(): AssignmentExpressionContext;
    varIdentifierList(): VarIdentifierListContext;
    get ruleIndex(): number;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class BusDeclarationContext extends ParserRuleContext {
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    busHeader(): BusHeaderContext;
    signalIdentifierList(): SignalIdentifierListContext;
    get ruleIndex(): number;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class ComponentMainDeclarationContext extends ParserRuleContext {
    _argValues: ExpressionListContext;
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    COMPONENT(): TerminalNode;
    MAIN(): TerminalNode;
    ASSIGNMENT(): TerminalNode;
    ID(): TerminalNode;
    LP(): TerminalNode;
    RP(): TerminalNode;
    SEMICOLON(): TerminalNode;
    publicInputsDefinition(): PublicInputsDefinitionContext;
    expressionList(): ExpressionListContext;
    get ruleIndex(): number;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class BodyContext extends ParserRuleContext {
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    LC(): TerminalNode;
    RC(): TerminalNode;
    statements_list(): StatementsContext[];
    statements(i: number): StatementsContext;
    get ruleIndex(): number;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class StatementsContext extends ParserRuleContext {
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    declarations(): DeclarationsContext;
    SEMICOLON(): TerminalNode;
    ifStatements(): IfStatementsContext;
    regularStatements(): RegularStatementsContext;
    logDefinition(): LogDefinitionContext;
    assertDefinition(): AssertDefinitionContext;
    get ruleIndex(): number;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class IfStatementsContext extends ParserRuleContext {
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    get ruleIndex(): number;
    copyFrom(ctx: IfStatementsContext): void;
}
export declare class IfWithFollowUpIfContext extends IfStatementsContext {
    _cond: ExpressionContext;
    constructor(parser: CircomParser, ctx: IfStatementsContext);
    IF(): TerminalNode;
    LP(): TerminalNode;
    RP(): TerminalNode;
    ifStatements(): IfStatementsContext;
    expression(): ExpressionContext;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class IfRegularElseRegularContext extends IfStatementsContext {
    _cond: ExpressionContext;
    constructor(parser: CircomParser, ctx: IfStatementsContext);
    IF(): TerminalNode;
    LP(): TerminalNode;
    RP(): TerminalNode;
    regularStatements_list(): RegularStatementsContext[];
    regularStatements(i: number): RegularStatementsContext;
    ELSE(): TerminalNode;
    expression(): ExpressionContext;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class IfRegularElseWithFollowUpIfContext extends IfStatementsContext {
    _cond: ExpressionContext;
    constructor(parser: CircomParser, ctx: IfStatementsContext);
    IF(): TerminalNode;
    LP(): TerminalNode;
    RP(): TerminalNode;
    regularStatements(): RegularStatementsContext;
    ELSE(): TerminalNode;
    ifStatements(): IfStatementsContext;
    expression(): ExpressionContext;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class IfRegularContext extends IfStatementsContext {
    _cond: ExpressionContext;
    constructor(parser: CircomParser, ctx: IfStatementsContext);
    IF(): TerminalNode;
    LP(): TerminalNode;
    RP(): TerminalNode;
    regularStatements(): RegularStatementsContext;
    expression(): ExpressionContext;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class RegularStatementsContext extends ParserRuleContext {
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    get ruleIndex(): number;
    copyFrom(ctx: RegularStatementsContext): void;
}
export declare class RStatementEqConstraintContext extends RegularStatementsContext {
    _lhs: ExpressionContext;
    _rhs: ExpressionContext;
    constructor(parser: CircomParser, ctx: RegularStatementsContext);
    EQ_CONSTRAINT(): TerminalNode;
    SEMICOLON(): TerminalNode;
    expression_list(): ExpressionContext[];
    expression(i: number): ExpressionContext;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class RStatementSucstitutionsContext extends RegularStatementsContext {
    constructor(parser: CircomParser, ctx: RegularStatementsContext);
    substitutions(): SubstitutionsContext;
    SEMICOLON(): TerminalNode;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class RStatementCyclesContext extends RegularStatementsContext {
    constructor(parser: CircomParser, ctx: RegularStatementsContext);
    cycleStatements(): CycleStatementsContext;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class RStatementReturnContext extends RegularStatementsContext {
    _value: ExpressionContext;
    constructor(parser: CircomParser, ctx: RegularStatementsContext);
    RETURN(): TerminalNode;
    SEMICOLON(): TerminalNode;
    expression(): ExpressionContext;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class RStatementExpressionContext extends RegularStatementsContext {
    constructor(parser: CircomParser, ctx: RegularStatementsContext);
    expression(): ExpressionContext;
    SEMICOLON(): TerminalNode;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class RStatementBodyContext extends RegularStatementsContext {
    constructor(parser: CircomParser, ctx: RegularStatementsContext);
    body(): BodyContext;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class CycleStatementsContext extends ParserRuleContext {
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    get ruleIndex(): number;
    copyFrom(ctx: CycleStatementsContext): void;
}
export declare class CycleForWithoutDeclarationContext extends CycleStatementsContext {
    _cond: ExpressionContext;
    _step: SubstitutionsContext;
    _forBody: RegularStatementsContext;
    constructor(parser: CircomParser, ctx: CycleStatementsContext);
    FOR(): TerminalNode;
    LP(): TerminalNode;
    substitutions_list(): SubstitutionsContext[];
    substitutions(i: number): SubstitutionsContext;
    SEMICOLON_list(): TerminalNode[];
    SEMICOLON(i: number): TerminalNode;
    RP(): TerminalNode;
    expression(): ExpressionContext;
    regularStatements(): RegularStatementsContext;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class CycleWhileContext extends CycleStatementsContext {
    _cond: ExpressionContext;
    _stmt: RegularStatementsContext;
    constructor(parser: CircomParser, ctx: CycleStatementsContext);
    WHILE(): TerminalNode;
    LP(): TerminalNode;
    RP(): TerminalNode;
    expression(): ExpressionContext;
    regularStatements(): RegularStatementsContext;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class CycleForWithDeclarationContext extends CycleStatementsContext {
    _cond: ExpressionContext;
    _step: SubstitutionsContext;
    _forBody: RegularStatementsContext;
    constructor(parser: CircomParser, ctx: CycleStatementsContext);
    FOR(): TerminalNode;
    LP(): TerminalNode;
    declarations(): DeclarationsContext;
    SEMICOLON_list(): TerminalNode[];
    SEMICOLON(i: number): TerminalNode;
    RP(): TerminalNode;
    expression(): ExpressionContext;
    substitutions(): SubstitutionsContext;
    regularStatements(): RegularStatementsContext;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class SubstitutionsContext extends ParserRuleContext {
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    get ruleIndex(): number;
    copyFrom(ctx: SubstitutionsContext): void;
}
export declare class SubsLeftAssignmentContext extends SubstitutionsContext {
    _lhs: ExpressionContext;
    _op: Token;
    _rhs: ExpressionContext;
    constructor(parser: CircomParser, ctx: SubstitutionsContext);
    expression_list(): ExpressionContext[];
    expression(i: number): ExpressionContext;
    ASSIGNMENT(): TerminalNode;
    LEFT_ASSIGNMENT(): TerminalNode;
    LEFT_CONSTRAINT(): TerminalNode;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class SubsRightConstrAssignmentContext extends SubstitutionsContext {
    _lhs: ExpressionContext;
    _op: Token;
    _variable: ExpressionContext;
    constructor(parser: CircomParser, ctx: SubstitutionsContext);
    expression_list(): ExpressionContext[];
    expression(i: number): ExpressionContext;
    RIGHT_CONSTRAINT(): TerminalNode;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class SubsRightSimpleAssignmentContext extends SubstitutionsContext {
    _lhs: ExpressionContext;
    _op: Token;
    _variable: ExpressionContext;
    constructor(parser: CircomParser, ctx: SubstitutionsContext);
    expression_list(): ExpressionContext[];
    expression(i: number): ExpressionContext;
    RIGHT_ASSIGNMENT(): TerminalNode;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class SubsInvalidIcnDecOperationContext extends SubstitutionsContext {
    constructor(parser: CircomParser, ctx: SubstitutionsContext);
    SELF_OP(): TerminalNode;
    identifierStatement(): IdentifierStatementContext;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class SubsAssignmentWithOperationContext extends SubstitutionsContext {
    _op: Token;
    _rhs: ExpressionContext;
    constructor(parser: CircomParser, ctx: SubstitutionsContext);
    identifierStatement(): IdentifierStatementContext;
    ASSIGNMENT_WITH_OP(): TerminalNode;
    expression(): ExpressionContext;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class SubsIcnDecOperationContext extends SubstitutionsContext {
    constructor(parser: CircomParser, ctx: SubstitutionsContext);
    identifierStatement(): IdentifierStatementContext;
    SELF_OP(): TerminalNode;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class ExpressionListContext extends ParserRuleContext {
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    expression_list(): ExpressionContext[];
    expression(i: number): ExpressionContext;
    COMMA_list(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    get ruleIndex(): number;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class ExpressionListWithNamesContext extends ParserRuleContext {
    _ops: Token;
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    ID_list(): TerminalNode[];
    ID(i: number): TerminalNode;
    expression_list(): ExpressionContext[];
    expression(i: number): ExpressionContext;
    ASSIGNMENT_list(): TerminalNode[];
    ASSIGNMENT(i: number): TerminalNode;
    LEFT_ASSIGNMENT_list(): TerminalNode[];
    LEFT_ASSIGNMENT(i: number): TerminalNode;
    LEFT_CONSTRAINT_list(): TerminalNode[];
    LEFT_CONSTRAINT(i: number): TerminalNode;
    COMMA_list(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    get ruleIndex(): number;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class ExpressionContext extends ParserRuleContext {
    _cond: ExpressionContext;
    _op: Token;
    _ifTrue: ExpressionContext;
    _ifFalse: ExpressionContext;
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    primaryExpression(): PrimaryExpressionContext;
    expression_list(): ExpressionContext[];
    expression(i: number): ExpressionContext;
    NOT(): TerminalNode;
    BNOT(): TerminalNode;
    SUB(): TerminalNode;
    PARALLEL(): TerminalNode;
    POW(): TerminalNode;
    MUL(): TerminalNode;
    DIV(): TerminalNode;
    QUO(): TerminalNode;
    MOD(): TerminalNode;
    ADD(): TerminalNode;
    SHL(): TerminalNode;
    SHR(): TerminalNode;
    BAND(): TerminalNode;
    BXOR(): TerminalNode;
    BOR(): TerminalNode;
    EQ(): TerminalNode;
    NEQ(): TerminalNode;
    LT(): TerminalNode;
    GT(): TerminalNode;
    LE(): TerminalNode;
    GE(): TerminalNode;
    AND(): TerminalNode;
    OR(): TerminalNode;
    TERNARY_CONDITION(): TerminalNode;
    TERNARY_ALTERNATIVE(): TerminalNode;
    get ruleIndex(): number;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class PrimaryExpressionContext extends ParserRuleContext {
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    get ruleIndex(): number;
    copyFrom(ctx: PrimaryExpressionContext): void;
}
export declare class PIdentifierStatementContext extends PrimaryExpressionContext {
    constructor(parser: CircomParser, ctx: PrimaryExpressionContext);
    identifierStatement(): IdentifierStatementContext;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class PUnderscoreContext extends PrimaryExpressionContext {
    constructor(parser: CircomParser, ctx: PrimaryExpressionContext);
    UNDERSCORE(): TerminalNode;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class PParenthesesContext extends PrimaryExpressionContext {
    constructor(parser: CircomParser, ctx: PrimaryExpressionContext);
    LP(): TerminalNode;
    expressionList(): ExpressionListContext;
    RP(): TerminalNode;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class PAnonymousCallContext extends PrimaryExpressionContext {
    constructor(parser: CircomParser, ctx: PrimaryExpressionContext);
    ID(): TerminalNode;
    LP_list(): TerminalNode[];
    LP(i: number): TerminalNode;
    RP_list(): TerminalNode[];
    RP(i: number): TerminalNode;
    expressionList_list(): ExpressionListContext[];
    expressionList(i: number): ExpressionListContext;
    expressionListWithNames(): ExpressionListWithNamesContext;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class PArrayContext extends PrimaryExpressionContext {
    constructor(parser: CircomParser, ctx: PrimaryExpressionContext);
    LB(): TerminalNode;
    expressionList(): ExpressionListContext;
    RB(): TerminalNode;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class PNumberContext extends PrimaryExpressionContext {
    constructor(parser: CircomParser, ctx: PrimaryExpressionContext);
    NUMBER(): TerminalNode;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class PCallContext extends PrimaryExpressionContext {
    constructor(parser: CircomParser, ctx: PrimaryExpressionContext);
    ID(): TerminalNode;
    LP(): TerminalNode;
    RP(): TerminalNode;
    expressionList(): ExpressionListContext;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class AssignmentExpressionContext extends ParserRuleContext {
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    get ruleIndex(): number;
    copyFrom(ctx: AssignmentExpressionContext): void;
}
export declare class AssignExprRegularContext extends AssignmentExpressionContext {
    _rhs: ExpressionContext;
    constructor(parser: CircomParser, ctx: AssignmentExpressionContext);
    ASSIGNMENT(): TerminalNode;
    expression(): ExpressionContext;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class AssignExprConstraintContext extends AssignmentExpressionContext {
    _rhs: ExpressionContext;
    constructor(parser: CircomParser, ctx: AssignmentExpressionContext);
    LEFT_CONSTRAINT(): TerminalNode;
    expression(): ExpressionContext;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class AssignExprSimpleContext extends AssignmentExpressionContext {
    _rhs: ExpressionContext;
    constructor(parser: CircomParser, ctx: AssignmentExpressionContext);
    LEFT_ASSIGNMENT(): TerminalNode;
    expression(): ExpressionContext;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class VarIdentifierContext extends ParserRuleContext {
    _rhs: ExpressionContext;
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    identifier(): IdentifierContext;
    ASSIGNMENT(): TerminalNode;
    expression(): ExpressionContext;
    get ruleIndex(): number;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class VarIdentifierListContext extends ParserRuleContext {
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    varIdentifier_list(): VarIdentifierContext[];
    varIdentifier(i: number): VarIdentifierContext;
    COMMA_list(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    get ruleIndex(): number;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class SignalIdentifierContext extends ParserRuleContext {
    _rhs: ExpressionContext;
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    identifier(): IdentifierContext;
    LEFT_ASSIGNMENT(): TerminalNode;
    expression(): ExpressionContext;
    LEFT_CONSTRAINT(): TerminalNode;
    get ruleIndex(): number;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class SignalIdentifierListContext extends ParserRuleContext {
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    signalIdentifier_list(): SignalIdentifierContext[];
    signalIdentifier(i: number): SignalIdentifierContext;
    COMMA_list(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    get ruleIndex(): number;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class IdentifierStatementContext extends ParserRuleContext {
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    ID(): TerminalNode;
    idetifierAccess_list(): IdetifierAccessContext[];
    idetifierAccess(i: number): IdetifierAccessContext;
    get ruleIndex(): number;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class IdentifierContext extends ParserRuleContext {
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    ID(): TerminalNode;
    arrayDimension_list(): ArrayDimensionContext[];
    arrayDimension(i: number): ArrayDimensionContext;
    get ruleIndex(): number;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class IdentifierListContext extends ParserRuleContext {
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    identifier_list(): IdentifierContext[];
    identifier(i: number): IdentifierContext;
    COMMA_list(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    get ruleIndex(): number;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class SimpleIdentifierListContext extends ParserRuleContext {
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    ID_list(): TerminalNode[];
    ID(i: number): TerminalNode;
    COMMA_list(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    get ruleIndex(): number;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class IdetifierAccessContext extends ParserRuleContext {
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    arrayDimension(): ArrayDimensionContext;
    identifierReferance(): IdentifierReferanceContext;
    get ruleIndex(): number;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class ArrayDimensionContext extends ParserRuleContext {
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    LB(): TerminalNode;
    expression(): ExpressionContext;
    RB(): TerminalNode;
    get ruleIndex(): number;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class IdentifierReferanceContext extends ParserRuleContext {
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    DOT(): TerminalNode;
    ID(): TerminalNode;
    get ruleIndex(): number;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class ExpressionOrStringContext extends ParserRuleContext {
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    expression(): ExpressionContext;
    STRING(): TerminalNode;
    get ruleIndex(): number;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class ExpressionOrStringListContext extends ParserRuleContext {
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    expressionOrString_list(): ExpressionOrStringContext[];
    expressionOrString(i: number): ExpressionOrStringContext;
    COMMA_list(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    get ruleIndex(): number;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
//# sourceMappingURL=CircomParser.d.ts.map