import { ExpressionContext } from "../generated";
import { CircomValueType, ParserErrorItem, VariableContext } from "../types";
export declare class ExpressionHelper {
    templateIdentifier: string;
    private _expressionContext;
    private _variableContext;
    constructor(templateIdentifier: string);
    setExpressionContext(expressionContext: ExpressionContext): ExpressionHelper;
    setVariableContext(variableContext: VariableContext): ExpressionHelper;
    addVariablesToTheContext(variables: VariableContext): ExpressionHelper;
    /**
     * This function can throw an error if the expression context is not set.
     * All other errors related to the parsing of the expression can be retrieved by the function `getErrors()`
     * inside the `ExtendedCircomVisitor` class.
     */
    parseExpression(): [CircomValueType | null, ParserErrorItem[]];
}
//# sourceMappingURL=ExpressionHelper.d.ts.map